Option Explicit On 
Imports System.Xml

' TI eBook Studio .NET
' version 1.2
' by mathDoom (c) 2003

Module Subor
#Region " Constants "

    Const tagSplit = "<--split-->"
    Const tagStart = "<mt t=on>"
    Const tagLineOn = "<mt r=on>"
    Const tagLineOff = "<mt r=off>"
    Const tagSpaceOn = "<mt c=on>"
    Const tagSpaceOff = "<mt c=off>"
    Const tagDoubleOn = "<mt ds=on>"
    Const tagDoubleOff = "<mt ds=off>"
    Const CRLF = Chr(13) + Chr(10)
    Const l_limit As Long = 63000
#End Region

#Region " Common procedures "

    Function OtvorSubor(ByVal nazov As String) As Boolean
        'Open source text File
        'Returns True if successful
        On Error GoTo ErrHandler
        FileOpen(1, nazov, OpenMode.Input, OpenAccess.Read, OpenShare.LockWrite)
        OtvorSubor = True
        Exit Function
ErrHandler:
        OtvorSubor = False
    End Function

    Sub ZatvorSubor(ByVal cislo As Integer)
        Try
            FileClose(cislo)
        Catch
            'Error! Ups!
        End Try
    End Sub

    Function TrimIndex(ByRef retazec As String) As Long
        'Find last index for trimming string
        Dim indZnak, ind As Integer
        ind = InStrRev(retazec, ".")
        indZnak = InStrRev(retazec, "?") : If ind < indZnak Then ind = indZnak
        indZnak = InStrRev(retazec, "!") : If ind < indZnak Then ind = indZnak
        indZnak = InStrRev(retazec, ".'") + 1 : If ind < indZnak Then ind = indZnak
        indZnak = InStrRev(retazec, "?'") + 1 : If ind < indZnak Then ind = indZnak
        indZnak = InStrRev(retazec, "!'") + 1 : If ind < indZnak Then ind = indZnak
        indZnak = InStrRev(retazec, "." + Chr(34)) + 1 : If ind < indZnak Then ind = indZnak
        indZnak = InStrRev(retazec, "!" + Chr(34)) + 1 : If ind < indZnak Then ind = indZnak
        indZnak = InStrRev(retazec, "?" + Chr(34)) + 1 : If ind < indZnak Then ind = indZnak
        If ind = 0 Then ind = InStrRev(retazec, " ") 'fucked book
        If ind = 0 Then ind = Len(retazec) ' very fucked book
        TrimIndex = ind
    End Function

    Function CreateHeader(ByVal o1 As Boolean, ByVal o2 As Boolean, ByVal o3 As Boolean) As String
        'Create header
        Dim header As String
        'header = tagStart + Chr(13) + Chr(10)
        header = ""
        If o1 Then
            header = header + tagLineOn
        Else
            header = header + tagLineOff
        End If
        If o2 Then
            header = header + tagSpaceOn
        Else
            header = header + tagSpaceOff
        End If
        If o3 Then
            header = header + tagDoubleOn
        Else
            header = header + tagDoubleOff
        End If
        CreateHeader = header
    End Function

#End Region

#Region " Read / Write procedures "

    Function PrecitajCast(ByRef spracovane As Long, ByVal blockSize As Long, ByRef zvysok As String) As String
        Dim retazec As String
        zvysok = ""
        Dim velkost, ind As Long

        If blockSize <= 0 Then
            PrecitajCast = ""
            Exit Function
        End If
        velkost = LOF(1)
        If velkost - spracovane >= blockSize Then
            retazec = InputString(1, blockSize)
            spracovane += blockSize
            ind = TrimIndex(retazec)
            zvysok = LTrim(Right(retazec, Len(retazec) - ind))
            retazec = Left(retazec, ind)
        Else
            retazec = InputString(1, velkost - spracovane)
            spracovane += velkost - spracovane
        End If
        PrecitajCast = retazec
    End Function

    Sub ZapisCast(ByVal bookNo As Integer, ByRef nacitane As String, ByRef p As TiParams)
        'Write complete eBook to file
        Dim nazov As String
        Dim s As String
        Dim ls As Long
        If nacitane = "" Then Exit Sub 'book es empty, exit
        nazov = p.varname + Format(bookNo, "00")
        FileOpen(2, nazov + ".txt", OpenMode.Output)
        If p.latin Then
            s = Latin(nacitane)
            Print(2, s)
            ls = Len(s)
        Else
            Print(2, nacitane)
            ls = Len(nacitane)
        End If
        FileClose(2)
        'Run ttebkgen
        If p.m_edit Then
            Dim iform As New InfoForm(bookNo, ls, nazov)
            iform.ShowDialog()
        End If
        If p.run Then
            Try
                If Not p.picture Then
                    Shell("ttebkgen " + Chr(34) + nazov + ".txt" + Chr(34) + " " + p.varname + Format(bookNo, "00") + " " + Chr(34) + _
                           p.desc + " " + Format(bookNo, "00") + Chr(34), AppWinStyle.NormalFocus, True)
                Else
                    Shell("ttebkgen -t " + Chr(34) + p.picname + Chr(34) + " " + Chr(34) + nazov + ".txt" + Chr(34) + " " + p.varname + Format(bookNo, "00") + " " + Chr(34) + _
                          p.desc + " " + Format(bookNo, "00") + Chr(34), AppWinStyle.NormalFocus, True)
                End If
                ZmazKnihu(nazov, p.c_model, 1)
                System.Windows.Forms.Application.DoEvents() 'redraw window
            Catch
                MsgBox("TTEBKGEN.EXE not found in PATH!", MsgBoxStyle.Critical + MsgBoxStyle.OKOnly, "TIeBookStudio")
                End
            End Try
        End If
        'Delete temporary files
        If p.delete Then
            Try
                Kill(nazov + ".txt")
            Catch
                'TO DO:  Something is wrong
            End Try
        End If
    End Sub

    Function ZmazKnihu(ByVal nazov As String, ByVal typ As Integer, ByVal urob As Boolean) As String
        Dim koncovka As String
        ZmazKnihu = ""
        If typ = 1 Then
            koncovka = ".89y"
        ElseIf typ = 2 Then
            koncovka = ".9xy"
        Else : Exit Function
        End If
        ZmazKnihu = "del " + nazov + koncovka
        If urob Then
            Try
                Kill(nazov + koncovka)
            Catch
                'TO DO:  Book wasn't generated. Why?
            End Try
        End If
    End Function

    Sub CreateMakefile(ByRef p As TiParams, ByVal books As Integer)
        'Creates build.bat makefile
        Dim i As Integer
        Dim delstring As String
        'write header
        FileOpen(3, "build.bat", OpenMode.Output)
        PrintLine(3, "@ECHO OFF")
        PrintLine(3, "REM Makefile created by TIeBookStudio")
        PrintLine(3, "REM please visit http://mathdoom.cjb.net for more information")
        For i = 1 To books
            If Not p.picture Then
                PrintLine(3, "ttebkgen " + Chr(34) + p.varname + Format(i, "00") + ".txt" + Chr(34) + " " + p.varname + Format(i, "00") + " " + Chr(34) + _
                                     p.desc + " " + Format(i, "00") + Chr(34))
            Else
                PrintLine(3, "ttebkgen -t " + Chr(34) + p.picname + Chr(34) + " " + Chr(34) + p.varname + Format(i, "00") + ".txt" + Chr(34) + " " + p.varname + Format(i, "00") + " " + Chr(34) + _
                                      p.desc + " " + Format(i, "00") + Chr(34))
            End If
            delstring = ZmazKnihu(p.varname + Format(i, "00"), p.c_model, 0)
            If delstring <> "" Then
                PrintLine(3, delstring)
            End If

        Next
        'write footer
        PrintLine(3, "@ECHO ON")
        FileClose(3)
    End Sub
#End Region

#Region " Conversion "

    Function Preved(ByVal znak As String) As String
        Dim znak1 As String
        Select Case znak
            Case ""
                znak1 = "c"
            Case ""
                znak1 = "C"

            Case ""
                znak1 = "d'"
            Case ""
                znak1 = "D"

            Case ""
                znak1 = "e"
            Case ""
                znak1 = "E"

            Case ""
                znak1 = "l'"
            Case ""
                znak1 = "l'"
            Case ""
                znak1 = "L"

            Case ""
                znak1 = "n"
            Case ""
                znak1 = "N"

            Case ""
                znak1 = "r"
            Case ""
                znak1 = "R"

            Case ""
                znak1 = "s"
            Case ""
                znak1 = "S"

            Case ""
                znak1 = "t'"
            Case ""
                znak1 = "T"

            Case ""
                znak1 = "u"
            Case ""
                znak1 = "U"

            Case ""
                znak1 = "z"
            Case ""
                znak1 = "Z"
            Case ""
                znak1 = "Z"
            Case ""
                znak1 = Chr(34)
            Case ""
                znak1 = "..."
            Case ""
                znak1 = "-"
            Case Else
                znak1 = znak
        End Select
        Preved = znak1
    End Function

    Function Latin(ByRef s As String) As String
        Dim s2 As String()
        Dim i As Long
        s2 = Split(s, " ", -1, CompareMethod.Binary)
        For i = 0 To s2.GetUpperBound(0)
            s2(i) = LatinWord(s2(i))
        Next
        Latin = Join(s2)
    End Function

    Function LatinWord(ByRef s As String) As String
        Dim s2 As String = ""
        Dim i As Integer
        For i = 1 To Len(s)
            s2 += Preved(Mid(s, i, 1))
        Next
        LatinWord = s2
    End Function

#End Region

#Region " Method: Constant Size "

    Function ProcessFile(ByVal nazov As String, ByRef p As TiParams) As Boolean
        Dim poradie As Integer = 1
        Dim bookNo As Integer = 1
        Dim spracovane As Integer = 0
        Dim blockSize As Long = Int(p.size / p.parts)
        Dim book, nacitane, zvysok, zvysok1 As String
        zvysok = "" : zvysok1 = ""
        book = ""

        'Open input file
        If Not OtvorSubor(nazov) Then
            ProcessFile = False
            Exit Function
        End If

        Do While Not EOF(1)
            nacitane = PrecitajCast(spracovane, blockSize - Len(zvysok), zvysok1)
            If poradie > 1 Then
                book += CRLF + tagSplit + CRLF
            End If
            book += p.header + zvysok + nacitane
            If poradie >= p.parts Or EOF(1) Then
                ZapisCast(bookNo, book, p)
                bookNo += 1
                book = ""
                poradie = 0
            End If
            poradie += 1
            zvysok = zvysok1
        Loop
        If p.makefile And bookNo > 0 Then
            CreateMakefile(p, bookNo - 1)
        End If
        FileClose(1) 'Close input file
    End Function

#End Region

#Region " Method: Chapters "

    Function ProcessFile2(ByVal nazov As String, ByRef p As TiParams) As Boolean
        Dim spracovane As Integer = 0
        Dim bookNo As Integer = 1
        Dim stav As Integer
        Dim nacitane, zvysok, zvysok1, zvysok2, rozdelene As String
        Dim book As String
        zvysok = ""
        'Open input file
        If Not OtvorSubor(nazov) Then
            ProcessFile2 = False
            Exit Function
        End If
        Do While Not EOF(1)
            nacitane = PrecitajCast(spracovane, p.size - Len(zvysok), zvysok1)
            If nacitane = "" Then
                MsgBox("Chapter size si too big. Please increase eBook size.", MsgBoxStyle.Critical + MsgBoxStyle.OKOnly, "TIeBookStudio")
                ProcessFile2 = False
                ZatvorSubor(1)
                Exit Function
            End If
            rozdelene = zvysok + nacitane
            Rozdel(rozdelene, book, p, zvysok2)
            If EOF(1) Then
                If (bookNo = 1 Or book <> "") And IsInRange(zvysok2, p) Then
                    book += tagSplit + CRLF + p.header + zvysok2
                Else
                    book += RozdelKapitolu(zvysok2, p)
                    'book += zvysok2
                End If
            End If
            book = p.header + book ' add book header
            ZapisCast(bookNo, book, p)
            bookNo += 1
            book = ""
            zvysok = zvysok2 + zvysok1
        Loop
        If p.makefile And bookNo > 0 Then
            CreateMakefile(p, bookNo - 1)
        End If
        FileClose(1) 'Close input file
        ProcessFile2 = True
    End Function

    Function Rozdel(ByRef retazec As String, ByRef vystup As String, ByRef p As TiParams, ByRef zvysok As String) As Integer
        '
        'Input: retazec, p
        'Output: vystup, zvysok, stav
        'Status: 0 - # of chapters
        '
        Dim mySArray() As String
        Dim i, j As Integer
        Dim dlzka As Long
        Dim navrat As String = ""

        mySArray = Split(retazec, p.sstring)

        UpravRiadky(mySArray, p)

        navrat = mySArray(0) 'first chapter
        If InStr(navrat, CRLF) = 0 And mySArray.GetUpperBound(0) > 0 Then
            mySArray(1) = navrat + mySArray(1)
            navrat = ""
        End If

        'najdi poslednu kapitolu
        j = 1
        For i = 1 To mySArray.GetUpperBound(0)
            If (navrat = "" And i = 1) Or Not IsInRange(mySArray(i), p) Or (p.join And i = 1) Then
                '
            Else
                j = i
            End If
        Next

        For i = 1 To j - 1
            If (navrat = "" And i = 1) Or Not IsInRange(mySArray(i), p) Or (p.join And i = 1) Then
                'do nothing
                'TO DO: Rewrite this ...
            Else
                mySArray(i) = tagSplit + CRLF + p.header + mySArray(i)
            End If
        Next

        For i = 1 To j - 1
            navrat += RozdelKapitolu(mySArray(i), p)
        Next

        'Part of last chapter
        zvysok = ""
        For i = j To mySArray.GetUpperBound(0)
            zvysok += mySArray(i)
        Next
        vystup = navrat
        Rozdel = mySArray.GetUpperBound(0) + 1
    End Function

    Function RozdelKapitolu(ByRef s As String, ByRef p As TiParams) As String
        Dim navrat As String = ""
        Dim ss As String
        Dim si, sl As Long
        Dim i, pocet As Integer
        Dim dlzka As Long

        dlzka = Len(s)
        If p.split And dlzka > l_limit Then
            pocet = dlzka \ l_limit : If dlzka Mod l_limit <> 0 Then pocet += 1
            si = 1 'start index
            For i = 1 To pocet - 1
                ss = Mid(s, l_limit * (i - 1) + 1, l_limit) 'get part
                sl = TrimIndex(ss) 'size of part
                navrat += Mid(s, si, sl) + CRLF + tagSplit + CRLF + p.header
                si = si + sl + 1 'index of next part
            Next
            If si <= dlzka Then navrat += Mid(s, si, dlzka - si + 1) 'last part
            RozdelKapitolu = navrat
        Else
            RozdelKapitolu = s
        End If
    End Function

    Sub UpravRiadky(ByRef mySArray() As String, ByRef p As TiParams)
        Dim i As Integer
        Dim ind, d As Long
        Dim koniec As String
        For i = 0 To mySArray.GetUpperBound(0) - 1
            d = InStrRev(mySArray(i), CRLF) 'index posledneho enteru
            If d = 0 Then
                mySArray(i + 1) = p.sstring + mySArray(i + 1)
            ElseIf d = Len(mySArray(i)) - 1 Then
                mySArray(i + 1) = p.sstring + mySArray(i + 1)

            Else
                'uloz si koniec bloku
                koniec = Right(mySArray(i), Len(mySArray(i)) - d - 1)
                'skrat blok
                mySArray(i) = Left(mySArray(i), d + 1)
                'pridaj zvysok na zaciatok dalsieho bloku
                mySArray(i + 1) = koniec + p.sstring + mySArray(i + 1)
            End If
        Next
    End Sub

    Function IsInRange(ByRef s As String, ByVal p As TiParams) As Boolean
        'Test, if searched string is in range
        Dim range As Long
        range = InStr(s, p.sstring) + Len(p.sstring) - 1
        If range <= p.slimit Then
            IsInRange = True
        Else
            IsInRange = False
        End If

    End Function

#End Region

#Region " Configuration "

    Sub SaveConfig(ByRef p As TiParams)
        Dim s As String = ""
        Dim doc As New XmlDocument()
        s = "<config>"

        If p.latin Then s += WParam("latin", "1") Else s += WParam("latin", "0")
        If p.join Then s += WParam("join_title", "1") Else s += WParam("join_title", "0")
        If p.run Then s += WParam("run_ttebkgen", "1") Else s += WParam("run_ttebkgen", "0")
        If p.delete Then s += WParam("delete_temp", "1") Else s += WParam("delete_temp", "0")
        If p.makefile Then s += WParam("makefile", "1") Else s += WParam("makefile", "0")
        If p.t_line Then s += WParam("t_line", "1") Else s += WParam("t_line", "0")
        If p.t_space Then s += WParam("t_space", "1") Else s += WParam("t_space", "0")
        If p.t_double Then s += WParam("t_double", "1") Else s += WParam("t_double", "0")
        If p.split Then s += WParam("split", "1") Else s += WParam("split", "0")
        If p.m_edit Then s += WParam("m_edit", "1") Else s += WParam("m_edit", "0")
        s += WParam("c_model", Trim(Str(p.c_model))) 'typ kalkulacky
        s += "</config>"
        doc.LoadXml(s)
        'Save the document to a file.
        Try
            doc.Save(Application.StartupPath + "\TIeBookStudio.xml")
        Catch
            'Cannot save configfile
        End Try
    End Sub

    Sub LoadConfig(ByRef p As TiParams)
        Dim hodnota As String
        Dim Doc As New XmlDocument()
        Dim Nav As XPath.XPathNavigator
        Dim Iterator As XPath.XPathNodeIterator

        Try
            Doc.Load(Application.StartupPath + "\TIeBookStudio.xml")
        Catch
            ConfigDefault(p)
            Exit Sub
        End Try
        Nav = CType(Doc, XPath.IXPathNavigable).CreateNavigator()
        'Latin
        hodnota = RParam(Nav, "config/latin")
        If Trim(hodnota) = "1" Then p.latin = True Else p.latin = False
        'Join title
        hodnota = RParam(Nav, "config/join_title")
        If Trim(hodnota) = "0" Then p.join = False Else p.join = True
        'Run ttebkgen
        hodnota = RParam(Nav, "config/run_ttebkgen")
        If Trim(hodnota) = "0" Then p.run = False Else p.run = True
        'Delete temp
        hodnota = RParam(Nav, "config/delete_temp")
        If Trim(hodnota) = "0" Then p.delete = False Else p.delete = True
        'Makefile
        hodnota = RParam(Nav, "config/makefile")
        If Trim(hodnota) = "1" Then p.makefile = True Else p.makefile = False
        'TTEBKGEN options
        hodnota = RParam(Nav, "config/t_line")
        If Trim(hodnota) = "1" Then p.t_line = True Else p.t_line = False
        hodnota = RParam(Nav, "config/t_space")
        If Trim(hodnota) = "0" Then p.t_space = False Else p.t_space = True
        hodnota = RParam(Nav, "config/t_double")
        If Trim(hodnota) = "1" Then p.t_double = True Else p.t_double = False
        'Split chapters
        hodnota = RParam(Nav, "config/split")
        If Trim(hodnota) = "0" Then p.split = False Else p.split = True
        'Edit before Run
        hodnota = RParam(Nav, "config/m_edit")
        If Trim(hodnota) = "1" Then p.m_edit = True Else p.m_edit = False
        'Calc model
        hodnota = RParam(Nav, "config/c_model")
        If Trim(hodnota) = "1" Then
            p.c_model = 1
        ElseIf Trim(hodnota) = "2" Then
            p.c_model = 2
        Else
            p.c_model = 0
        End If
    End Sub

    Function WParam(ByVal desc As String, ByVal value As String) As String
        WParam = "<" + desc + ">" + value + "</" + desc + ">"
    End Function

    Function RParam(ByRef nav As XPath.XPathNavigator, ByVal s As String) As String
        Dim Iterator As XPath.XPathNodeIterator
        Iterator = nav.Select(s)
        Iterator.MoveNext()
        RParam = Iterator.Current.Value()
    End Function

    Sub ConfigDefault(ByRef p As TiParams)
        'Set config defaults
        p.latin = False
        p.join = True
        p.split = True
        p.run = True
        p.delete = True
        p.makefile = False
        p.t_line = False
        p.t_space = True
        p.t_double = False
    End Sub

#End Region

End Module
